//--------------------------------------------------------------------//
// nV

var canvas;				// LoXvf
var context;	 			// ReLXg
var pressed;				// }EX{^
var mx,my;				// }EXʒu
var cx,cy;				// ʒSʒu
var image;				// `p摜
var imgRegion=[];			// `p摜ɑΉ̈
var width,height;			// f[^̈敝E
var base,baseWidth,baseHeight;		// 摜f[^EE
var viewMode;				// \[h
var map;				// Qn}
var regions=[];				// }bv̈惊Xg
var radius,radiusMax,radiusMin;		// nVaEőlEŏl
var theta,phy;				// _px
var px,py;				// |C^W
var regionMap={};			// ̈於\i[}bv

// n}\[h
var GLOBE=0;				// nV[h
var ECP=1;				// ~}@[h
var MOLLWEIDE=2;			// Cf}@[h
var AEP=3;				// ʐ}@[h

var PI2=2*Math.PI;			// ~2{
var PI_INV=1/Math.PI;			// ~̋t
var TOLERANCE=1.0e-10;			// n}ϊ̋e덷
var RADIUS_COEF=1.2;			// gEk
var FONT_SIZE=14;			// tHgTCY
var THETA_X=15.0,THETA_Y=10.0;		// _oxEܓxω
var BG_COLOR=[0,0,0,255];		// wiF
var TEXT_COLOR='rgb(0,0,0)';		// ̈於\F
var BOARD_COLOR='rgb(255,255,255)';	// ̈於\wiF

// nV
// fileName - f[^t@C
// imageName - 摜t@C
function initWorldMap(fileName,imageName){
  initCanvas();
  readWorldMapFiles(fileName,imageName);
}

// LoX
function initCanvas(){
  canvas=document.getElementById('wmap');
  width=canvas.clientWidth;
  height=canvas.clientHeight;
  canvas.width=width;
  canvas.height=height;
  canvas.addEventListener('mousedown',mousePressed,false);
  canvas.addEventListener('mouseup',mouseReleased,false);
  canvas.addEventListener('mousemove',mouseMoved,false);
  document.addEventListener('keydown',keyPressed,false);
  context=canvas.getContext('2d');
  context.font=FONT_SIZE+"px 'Arial'";
  context.textBaseline='top';
  image=context.createImageData(width,height);
  var pixel=image.data,size=width*height;
  for(var i=0;i<size;i++){
    imgRegion[i]=-1;
    var i4=4*i;
    pixel[i4]=BG_COLOR[0];
    pixel[i4+1]=BG_COLOR[1];
    pixel[i4+2]=BG_COLOR[2];
    pixel[i4+3]=BG_COLOR[3];
  }
  pressed=false;
  mx=0;
  my=0;
  cx=width/2;
  cy=height/2;
  radius=parseInt(0.8*Math.min(cx,cy));
  radiusMax=3*radius;
  radiusMin=radius;
  theta=0;
  phy=0;
  px=0;
  py=0;
}

// }EX{^̏s
function mousePressed(e){
  pressed=true;
  mx=e.clientX;
  my=e.clientY;
  var rect=e.target.getBoundingClientRect();
  addNameBoard(mx-rect.left,my-rect.top);
  draw();
}

// }EX{^𗣂̏s
function mouseReleased(e){
  pressed=false;
}

// }EX{^ړ̏s
function mouseMoved(e){
  if(pressed){
    rotate(mx-e.clientX,e.clientY-my);
    mx=e.clientX;
    my=e.clientY;
    draw();
  }
}

// L[̏s
function keyPressed(e){
  switch(e.keyCode){
    case 37:		// (Numpad4 Off)
    case 100:		// Numpad4 On
      rotate(THETA_X,0);
      draw();
      break;
    case 39:		// E(Numpad6 Off)
    case 102:		// Numpad6 On
      rotate(-THETA_X,0);
      draw();
      break;
    case 40:		// (Numpad2 Off)
    case 98:		// Numpad2 On
      rotate(0,THETA_Y);
      draw();
      break;
    case 38:		// (Numpad8 Off)
    case 104:		// Numpad8 On
      rotate(0,-THETA_Y);
      draw();
      break;
    case 35:		// End(Numpad1 Off)
    case 49:		// 1
    case 97:		// Numpad1 On
    case 107:		// Numpad+
    case 187:		// +
      zoomin();
      break;
    case 45:		// Ins(Numpad0 Off)
    case 48:		// 0
    case 96:		// Numpad0 On
    case 109:		// Numpad-
    case 189:		// -
      zoomout();
      break;
    case 12:		// (Numpad5 Off)
    case 53:		// 5
    case 67:		// C
    case 101:		// Numpad5 On
      moveCenter();
      draw();
      break;
    case 68:		// D
      clearRegionName();
      break;
  }
}

// nVf[^t@Cǂݍ
// fileName - f[^t@C
// imageName - 摜t@C
function readWorldMapFiles(fileName,imageName){
  if((imageName!==undefined) && (imageName!==null)){
    var imageBase=new Image();
    imageBase.src=imageName;
    imageBase.onload=function(){
      readWorldMapFile(fileName,imageBase);
    };
  }
  else{
    readWorldMapFile(fileName,null);
  }
}

// nVf[^t@Cǂݍ
// fileName - f[^t@C
// imageBase - 摜f[^
function readWorldMapFile(fileName,imageBase){
  var xhr=new XMLHttpRequest();
  try{
    xhr.open('GET',fileName,false);
  }
  catch(e){
    alert(e);
  }
  xhr.onreadystatechange=function(){
    if((xhr.readyState===4) && ((xhr.status===0) || (xhr.status===200))){
      readTextData(xhr.responseText.split(/\r?\n/g),imageBase);
      setMode();
    }
  };
  xhr.send(null);
}

// nVeLXgf[^t@Cǂݍ
// s - f[^̃Xg
// imageBase - 摜f[^
function readTextData(s,imageBase){
  var ii=0,jj=0,i;
  var hasImageFile=(imageBase!==null);
  var regionMap=[];
  base=[];
  baseWidth=360;
  baseHeight=720;
  regions.length=0;
  while(ii<s.length){
    var ss=s[ii].trim().replace(/\t/g,' ').split(/\s+/);
    if(ss.length>=3){
      var keyWord=ss[0].toLowerCase();
      if(keyWord=='init'){
      	theta=Number(ss[1])/360;
      	phy=Number(ss[2])/180;
      }
      else if(keyWord=='region'){
      	if(!hasImageFile){
      	  baseWidth=parseInt(ss[1]);
      	  baseHeight=parseInt(ss[2]);
      	  var size=baseWidth*baseHeight;
      	  for(i=0;i<size;i++) base[i]=0;
      	}
      }
      else{
      	var color=parseInt(ss[1],16);
      	regions.push(new Region(ss[2],color));
      	regionMap[color]=regions.length-1;
      }
    }
    else if(ss.length==2){
      var count=parseInt(ss[0]);
      var pt=parseInt(ss[1]);
      for(i=0;i<count;i++){
      	base[jj]=pt;
      	jj++;
      }
    }
    ii++;
  }
  if(hasImageFile){
    var pixCanvas=document.createElement('canvas');
    baseWidth=imageBase.width;
    baseHeight=imageBase.height;
    pixCanvas.width=baseWidth;
    pixCanvas.height=baseHeight;
    var pixCont=pixCanvas.getContext('2d');
    pixCont.drawImage(imageBase,0,0);
    var pixel=pixCont.getImageData(0,0,baseWidth,baseHeight).data;
    for(i=0;i<baseWidth;i++){
      for(var j=0;j<baseHeight;j++){
      	var index=baseWidth*j+i;
      	var idx4=4*index;
      	var pix=(pixel[idx4]<<16)|(pixel[idx4+1]<<8)|pixel[idx4+2];
      	base[index]=regionMap[pix];
      }
    }
  }
  regionMap=null;
}

// gEk
// coef - ågEkW
function zoom(coef){
  if((viewMode==GLOBE) || (viewMode==AEP)){
    radius=Math.max(Math.min(parseInt(coef*radius),radiusMax),
      	      	    radiusMin);
    draw();
  }
}

// _ʒu]
// dx,dy - x,yWړ
function rotate(dx,dy){
  theta+=map.vx*dx;
  if(theta>0.5)       theta-=1;
  else if(theta<-0.5) theta+=1;
  phy=Math.min(Math.max(phy+map.vy*dy,-0.5),0.5);
}

// ̈於\ǉ
// x,y - \ʒu
function addNameBoard(x,y){
  var pt=map.getPoint(x,y);
  if(pt>=0){
    px=pt%baseWidth;
    py=(pt-px)/baseWidth;
    pt=base[pt];
  }
  if(pt>1){
    var rg=regions[pt];
    if(rg.name in regionMap){
      regionMap[rg.name].set(px,py);
    }
    else{
      regionMap[rg.name]=new NameBoard(rg,px,py);
    }
    draw();
  }
}

// `悷
function draw(){
  var pixel=image.data,ii=0,k;
  for(var j=0;j<height;j++){
    for(var i=0;i<width;i++){
      var p=map.getPoint(i,j);
      var i4=4*ii;
      if(imgRegion[ii]!=p){
      	if(p<0){
      	  imgRegion[ii]=p;
      	  for(k=0;k<4;k++) pixel[i4+k]=BG_COLOR[k];
      	}
      	else{
      	  imgRegion[ii]=base[p];
      	  var rgba=regions[base[p]].rgba;
      	  for(k=0;k<4;k++) pixel[i4+k]=rgba[k];
      	}
      }
      ii++;
    }
  }
  context.putImageData(image,0,0);
  for(var key in regionMap){
    regionMap[key].draw();
  }
}

// \g傷
function zoomin(){
  zoom(RADIUS_COEF);
}

// \k
function zoomout(){
  zoom(1.0/RADIUS_COEF);
}

// NbN_𒆐Sֈړ
function moveCenter(){
  theta=px/baseWidth-0.5;
  phy=0.5-py/baseHeight;
  draw();
}

// ̈於\
function clearRegionName(){
  for(var key in regionMap){
    delete regionMap[key];
  }
  draw();
}

// \[hݒ肷
function setMode(){
  var mode=document.getElementById('mode').value;
  if(mode=='globe'){
    viewMode=GLOBE;
    map=new GlobeMap();
  }
  else if(mode=='ecp'){
    viewMode=ECP;
    map=new ECPMap();
  }
  else if(mode=='mollweide'){
    viewMode=MOLLWEIDE;
    map=new MollweideMap();
  }
  else if(mode=='aep'){
    viewMode=AEP;
    map=new AEPMap();
  }
  draw();
}

// pNX쐬
// ctor - VNX
// superCtor - pNX
function inherits(ctor,superCtor){
  if((ctor===undefined) || (ctor===null))
    throw new TypeError('The constructor to `inherits` must not be '+
                        'null or undefined.');

  if((superCtor===undefined) || (superCtor===null))
    throw new TypeError('The super constructor to `inherits` must '+
                        'not be null or undefined.');

  if(superCtor.prototype===undefined)
    throw new TypeError('The super constructor to `inherits` must '+
                        'have a prototype.');
  ctor.super_=superCtor;
  Object.setPrototypeOf(ctor.prototype,superCtor.prototype);
}

//--------------------------------------------------------------------//
// }bv̈
// name - ̈於
// color - ̈̐F
var Region=function(name,color){
  this.name=name;
  this.color=color;
  this.rgba=[(color>>16&0xff),(color>>8&0xff),(color&0xff),255];
};

//--------------------------------------------------------------------//
// n}̓_
// x,y - oxEܓx
var Point=function(x,y){
  this.x=x;
  this.y=y;
};

// Wݒ肷
// x,y - oxEܓx
Point.prototype.set=function(x,y){
  this.x=x;
  this.y=y;
};

//--------------------------------------------------------------------//
// ̈於\
// region - }bv̈
// px,py - \ʒu|C^
var NameBoard=function(region,px,py){
  this.region=region;
  this.color='rgb('+region.rgba[0]+','+region.rgba[1]+','+region.rgba[2]+')';
  this.px=px;
  this.py=py;
};

// \ʒuݒ肷
// px,py - \ʒu|C^
NameBoard.prototype.set=function(px,py){
  this.px=px;
  this.py=py;
};

// ̈於`悷
NameBoard.prototype.draw=function(){
  var p=map.getViewPoint(this.px,this.py);
  if(p!==null){
    var metrix=context.measureText(this.region.name);
    var x=p.x,y=p.y,w=metrix.width+2,h=FONT_SIZE+2;
    if(x+w>width){
      x-=w;
    }
    if(y+h>height){
      y-=h;
    }
    context.fillStyle=BOARD_COLOR;
    context.fillRect(x,y,w,h);
    context.strokeStyle=this.color;
    context.strokeRect(x,y,w,h);
    context.fillStyle=TEXT_COLOR;
    context.fillText(this.region.name,x,y);
  }
};

//--------------------------------------------------------------------//
// Qn}
var Map2D=function(){
  this.vx=0;
  this.vy=0;
  this.point=new Point();
};

//--------------------------------------------------------------------//
// nV
var GlobeMap=function(){
  Map2D.call(this);
  this.vx=0.25/radius;
  this.vy=2*this.vx;
};

// n}̗̈CfbNXԂ
// x,y - ʏ̑Έʒu
GlobeMap.prototype.getPoint=function(x,y){
  x=(x-cx)/radius;
  y=(cy-y)/radius;
  var r2=1-(x*x+y*y);
  if(r2<0) return -1;

  var ph=Math.PI*phy;
  var sphy=Math.sin(ph);
  var cphy=Math.cos(ph);
  var r=Math.sqrt(r2);
  var ssy=sphy*r+cphy*y;
  var ccy=1-ssy*ssy;
  if(ccy<TOLERANCE){
    if(ssy>0){		// kɓ_
      return 0;
    }
    else{		// ɓ_
      return baseWidth*baseHeight-1;
    }
  }
  else{
    var yy=PI_INV*Math.asin(ssy);
    var ccx=(cphy*r-sphy*y)/Math.sqrt(ccy);
    var xx=0.0;
    if(ccx<-1+TOLERANCE)      xx=0.5;
    else if(ccx<=1-TOLERANCE) xx=0.5*PI_INV*Math.acos(ccx);
    if(x<0) xx=-xx;
    var i=parseInt(baseWidth/2+baseWidth*(1+xx+theta));
    var j=parseInt(baseHeight/2-baseHeight*yy);
    return baseWidth*j+i%baseWidth;
  }
};

// n}̈ʒuԂ
// x,y - f[^ʒu
GlobeMap.prototype.getViewPoint=function(x,y){
  var th=PI2*theta,ph=Math.PI*phy;
  var rx=PI2*(x/baseWidth-0.5);
  var ry=Math.PI*(y/baseHeight-0.5);
  var cry=Math.cos(ry);
  var px=Math.cos(rx)*cry;
  var py=Math.sin(rx)*cry;
  var pz=Math.sin(ry);
  var sth=Math.sin(th);
  var cth=Math.cos(th);
  var sphy=Math.sin(ph);
  var cphy=Math.cos(ph);
  var temp=px*cth+py*sth;
  var px2=-px*sth+py*cth;
  var py2=temp*sphy+pz*cphy;
  var pz2=temp*cphy-pz*sphy;
  if(pz2<0){
    return null;
  }
  else{
    this.point.set(parseInt(radius*px2+cx),parseInt(radius*py2+cy));
    return this.point;
  }
};

//--------------------------------------------------------------------//
// ~}@
var ECPMap=function(){
  Map2D.call(this);
  this.vx=1/width;
  this.vy=0;
};

// n}̗̈CfbNXԂ
// x,y - ʏ̑Έʒu
ECPMap.prototype.getPoint=function(x,y){
  var i=parseInt(baseWidth*(1+x/width+theta));
  var j=parseInt(baseHeight*y/height);
  return baseWidth*j+i%baseWidth;
};

// n}̈ʒuԂ
// x,y - f[^ʒu
ECPMap.prototype.getViewPoint=function(x,y){
  var gx=parseInt(width*(x/baseWidth+1-theta));
  var gy=parseInt(height*y/baseHeight);
  this.point.set(gx%width,gy);
  return this.point;
};

//--------------------------------------------------------------------//
// Cf}@
var MollweideMap=function(){
  Map2D.call(this);
  this.molWidth=4*width/5;
  this.molHeight=4*height/5;
  this.vx=1/this.molWidth;
  this.vy=0;
};

// n}̗̈CfbNXԂ
// x,y - ʏ̑Έʒu
MollweideMap.prototype.getPoint=function(x,y){
  x=2*(x-cx)/this.molWidth;
  y=2*(cy-y)/this.molHeight;
  if(x*x+y*y>=1){
    return -1;
  }
  else if(y>1-TOLERANCE){		// kɓ_
    return 0;
  }
  else if(y<-1+TOLERANCE){	// ɓ_
    return baseWidth*baseHeight-1;
  }
  else{
    var xx=x/Math.sqrt(1-y*y);
    var yy=2.0*Math.asin(y);
    yy=PI_INV*Math.asin(PI_INV*(yy+Math.sin(yy)));
    var i=parseInt(baseWidth*3/2+baseWidth*(0.5*xx+theta));
    var j=parseInt(baseHeight/2-baseHeight*yy);
    return baseWidth*j+i%baseWidth;
  }
};

// n}̈ʒuԂ
// x,y - f[^ʒu
MollweideMap.prototype.getViewPoint=function(x,y){
  var xx=2.0*(x/baseWidth-0.5-theta);
  if(xx>1)       xx-=2;
  else if(xx<-1) xx+=2;
  var ey=1;
  if(y===0){
    ey=-1;
  }
  else if(y<height-1){
    ey=Math.PI*(y/baseHeight-0.5);
    ey=Math.sin(0.5*eccentricAnomaly(Math.PI*Math.sin(ey),-1.0));
  }
  var ex=xx*Math.sqrt(1-ey*ey);
  this.point.set(parseInt(0.5*this.molWidth*ex+cx),
      	      	 parseInt(0.5*this.molHeight*ey+cy));
  return this.point;
};

//--------------------------------------------------------------------//
// ʐ}@
var AEPMap=function(){
  Map2D.call(this);
  this.vx=0.25/radius;
  this.vy=2*this.vx;
};

// n}̗̈CfbNXԂ
// x,y - ʏ̑Έʒu
AEPMap.prototype.getPoint=function(x,y){
  x=(x-cx)/radius;
  y=(cy-y)/radius;
  var i,j;
  var r2=x*x+y*y;
  if(r2>1){
    return -1;
  }
  else if(r2===0){		// S_
    i=parseInt(baseWidth*(1.5+theta));
    j=parseInt(baseHeight*(0.5-phy));
    return baseWidth*j+i%baseWidth;
  }
  else{
    var ph=Math.PI*phy;
    var sphy=Math.sin(ph);
    var cphy=Math.cos(ph);
    var r=Math.sqrt(r2);
    var gy=y/r;
    r*=Math.PI;
    var ssd=Math.sin(r);
    var ccd=Math.cos(r);
    var ssy=sphy*ccd+cphy*ssd*gy;
    var ccy=1-ssy*ssy;
    if(ccy<TOLERANCE){
      if(ssy>0){	// kɓ_
      	return 0;
      }
      else{		// ɓ_
      	return baseWidth*baseHeight-1;
      }
    }
    else{
      var yy=PI_INV*Math.asin(ssy);
      var ccx=(cphy*ccd-sphy*ssd*gy)/Math.sqrt(ccy);
      var xx=0.0;
      if(ccx<-1+TOLERANCE)      xx=0.5;
      else if(ccx<=1-TOLERANCE) xx=0.5*PI_INV*Math.acos(ccx);
      if(x<0) xx=-xx;
      i=parseInt(baseWidth/2+baseWidth*(1+xx+theta));
      j=parseInt(baseHeight/2-baseHeight*yy);
      return baseWidth*j+i%baseWidth;
    }
  }
};

// n}̈ʒuԂ
// x,y - f[^ʒu
AEPMap.prototype.getViewPoint=function(x,y){
  var ph=Math.PI*phy;
  var sphy=Math.sin(ph);
  var cphy=Math.cos(ph);
  var xx=PI2*(x/baseWidth-0.5-theta);
  var yy=-Math.PI*(y/baseHeight-0.5);

  var cxx=Math.cos(xx);
  var cyy=Math.cos(yy);
  var syy=Math.sin(yy);
  var ccd=cphy*cxx*cyy+sphy*syy;
  var ssd=1-ccd*ccd;
  if(ssd<TOLERANCE){
    if(ccd>0){	// S_
      this.point.set(cx,cy);
    }
    else{		// [_
      this.point.set(radius+cx,cy);
    }
  }
  else{
    var delta=PI_INV*Math.acos(ccd);
    var ey=(-sphy*cxx*cyy+cphy*syy)/Math.sqrt(ssd);
    var ex=delta*Math.sqrt(1.0-ey*ey);
    ey*=delta;
    if(Math.sin(xx)<0.0) ex=-ex;
    this.point.set(parseInt(radius*ex+cx),parseInt(-radius*ey+cy));
  }
  return this.point;
};

// Newtion @gpėSߓ_p߂
// m - ϋߓ_p
// eccen - S
function eccentricAnomaly(m,eccen){
  var ei=m+eccen*Math.sin(m);
  var mi=ei-eccen*Math.sin(ei);
  var dm=Math.abs(m-mi);
  while(dm>TOLERANCE){
    ei=ei+(m-mi)/(1.0-eccen*Math.cos(ei));
    mi=ei-eccen*Math.sin(ei);
    dm=Math.abs(m-mi);
  }
  return ei;
}

inherits(GlobeMap,Map2D);
inherits(ECPMap,Map2D);
inherits(MollweideMap,Map2D);
inherits(AEPMap,Map2D);
